<?php

/**
 * @file
 * Pages callbacks, pages' forms callbacks and helper functions.
 */

/**
 * Devel snippet entity form builder.
 */
function devel_snippet_form($form, &$form_state, $entity, $op, $type = NULL) {
  $form['name'] = array(
    '#type' => 'textfield',
    '#title' => t('Name'),
    '#default_value' => $entity->name,
    '#required' => TRUE,
  );
  $form['code'] = array(
    '#type' => 'textarea',
    '#title' => t('PHP code to execute'),
    '#description' => t('Enter some code. Do not use <code>&lt;?php ?&gt;</code> tags.'),
    '#default_value' => $entity->code,
    '#required' => TRUE,
    '#rows' => 20,
  );

  $form['actions'] = array(
    '#type' => 'actions',
    '#weight' => 400,
  );
  $form['actions']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#submit' => array('devel_snippet_form_submit_save'),
  );
  if (!empty($entity->id)) {
    $form['actions']['delete'] = array(
      '#type' => 'submit',
      '#value' => t('Delete'),
      '#suffix' => l(t('Cancel'), 'devel/php/snippet'),
      '#submit' => array('devel_snippet_form_submit_delete'),
      '#weight' => 45,
    );
  }

  $form['#attributes']['class'][] = str_replace('_', '-', __FUNCTION__);
  return $form;
}

/**
 * Devel snippet entity form submit handler on save.
 */
function devel_snippet_form_submit_save($form, &$form_state) {
  $entity = entity_ui_controller('devel_snippet')
    ->entityFormSubmitBuildEntity($form, $form_state);
  $entity->save();

  $form_state['redirect'] = 'devel/php/snippet/manage/' . $entity->id;
  drupal_set_message(t('Code snippet has been saved.'));
}

/**
 * Devel snippet entity form submit handler on delete.
 */
function devel_snippet_form_submit_delete($form, &$form_state) {
  $entity = $form_state['devel_snippet'];
  $form_state['redirect'] = $form_state['redirect'] = 'devel/php/snippet/manage/' . $entity->id . '/delete';
}
